#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#include "procedit.h"

void createMenu();

int main(int argc, char **argv, char** env)
{
	id pool;
	NSApplication *theApp;

	pool = [NSAutoreleasePool new];
	
#if LIB_FOUNDATION_LIBRARY
  	[NSProcessInfo initializeWithArguments:argv count:argc environment:env];
#endif
#ifndef NX_CURRENT_COMPILER_RELEASE
  	initialize_gnustep_backend();
#endif
	
	theApp = [NSApplication sharedApplication];
	[theApp setDelegate: [ProcEdit sharedprocedit]];  

	createMenu();
  	NSRegisterServicesProvider([ProcEdit sharedprocedit], @"ProcViewer");
//	[NSPasteboard generalPasteboard];
	
	[theApp run];
	[pool release];
	
	return 0;
}

void createMenu()
{
	NSMenu* menu;
	NSMenu* info;
	NSMenu* services;

	SEL action = @selector(method:);

	menu = [[NSMenu alloc] initWithTitle:@"ProcViewer"];
	[menu addItemWithTitle:@"Info" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"Kill Process" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"Services" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"Quit" action:@selector(terminate:) keyEquivalent:@"q"];

	info = [NSMenu new];
	[menu setSubmenu:info forItem:[menu itemWithTitle:@"Info"]];
	[info addItemWithTitle:@"Info Panel..." action:action keyEquivalent:@""];
	[info addItemWithTitle:@"Help" action:action keyEquivalent:@"?"];

	services = [NSMenu new];
	[menu setSubmenu:services forItem:[menu itemWithTitle:@"Services"]];

	[[NSApplication sharedApplication] setMainMenu:menu];		
	[[NSApplication sharedApplication] setServicesMenu: services];
	[menu update];
	[menu display];
}
