#import "procedit.h"

static ProcEdit *sharedprocedit = nil;

@implementation ProcEdit

+ (ProcEdit *)sharedprocedit;
{
	if(!sharedprocedit) {
      NS_DURING
      {
	 	 	[gnustep_global_lock lock];
	  		sharedprocedit = [[self alloc] init];
	  		[gnustep_global_lock unlock];
		}
		NS_HANDLER
		{
	  		[gnustep_global_lock unlock];
	  		[localException raise];
		}
      NS_ENDHANDLER
	}
	return sharedprocedit;
}

- (void)applicationDidFinishLaunching:(NSNotification *)aNotification
{
	NSRect winRect = {{100, 100}, {600, 400}};
	NSRect scrollrect, buttsrect;
	unsigned int style = NSTitledWindowMask | NSClosableWindowMask				
							| NSMiniaturizableWindowMask | NSResizableWindowMask;

	r = [NSArray arrayWithObjects: NSStringPboardType, nil];
	s = [NSArray arrayWithObjects: NSStringPboardType, nil];
	[[NSApplication sharedApplication] registerServicesMenuSendTypes: s returnTypes: r];
 			
	win = [[NSWindow alloc] initWithContentRect:winRect
												 styleMask:style
												   backing:NSBackingStoreRetained
													  defer:NO];
	[win setTitle:@"ProcViewer.app"];
	[win setFrameAutosaveName:@"ProcViewer.app"]; 

	buttsrect = NSMakeRect(0, [win frame].size.height -30, 
															[win frame].size.width, 30);
	buttView = [[ButtView alloc] initWithFrame:buttsrect];
	[buttView setAutoresizingMask: NSViewHeightSizable | NSViewWidthSizable];
	[[win contentView] addSubview: buttView];
			  
	scrollrect = NSMakeRect(0, 0, [win frame].size.width, [win frame].size.height -30);
	scrollView = [[NSScrollView alloc] initWithFrame:scrollrect];
	[scrollView setHasHorizontalScroller:YES];
	[scrollView setHasVerticalScroller:YES]; 
	[scrollView setAutoresizingMask: NSViewHeightSizable | NSViewWidthSizable];

	procsFrame = [[ProcsFrame alloc] initWithFrame: [[scrollView contentView] frame]];
	[procsFrame setFrame:[[scrollView contentView] frame]];
	[scrollView setDocumentView:procsFrame];	

	[[win contentView] addSubview: scrollView];
	[win display];
	[win orderFront:nil];
}

- (BOOL)applicationShouldTerminate:(NSApplication *)app 
{
	return YES;
}

- (void)updatePopUp:(NSArray *)contents
{
	[buttView makePopUp: contents];
}

- (void)popupSwitchUser:(id)sender
{
 	NSString *usrname;

	usrname = [sender titleOfSelectedItem];
	if([usrname isEqualToString:@"Users"])
		return;
	[procsFrame showProcsOfUser: usrname];
}

- (void)method:menuCell
{

}

- (void)procInfo:(NSPasteboard*)bp
		  userData:(NSString*)ud
	   	  error:(NSString**)err
{
  	NSString *in;
  	NSString *out;
  	NSArray *types;


	printf("SIAMO QUA!\n");
	

  	types = [bp types];
  	if(![types containsObject: NSStringPboardType]) {
   	*err = @"No string type supplied on pasteboard";
		
		printf("No string type supplied on pasteboard\n");
		
      return;
	}

  	in = [bp stringForType: NSStringPboardType];
  	if(in == nil) {
  		*err = @"No string value supplied on pasteboard";
		
		printf("No string value supplied on pasteboard\n");
		
      return;
	}

  	out = [in lowercaseString];
  	types = [NSArray arrayWithObject: NSStringPboardType];
  	[bp declareTypes: types owner: nil];
  	[bp setString: out forType: NSStringPboardType];

}

@end
