#include "procobjwin.h"
#include "procobj.h"

#ifndef HZ
#define HZ 100
#endif

NSRect stateLabrect = {{10, 270}, {40, 15}};
NSRect userLabrect = {{10, 250}, {40, 15}};
NSRect ttyLabrect = {{10, 230}, {35, 15}};
NSRect pidLabrect = {{10, 210}, {35, 15}};
NSRect ppidLabrect = {{10, 190}, {35, 15}};
NSRect startTLabrect = {{10, 170}, {50, 15}};
NSRect cpuUsLabrect = {{10, 150}, {50, 15}};
NSRect sizeLabrect = {{10, 130}, {50, 15}};
NSRect memLabrect = {{10, 110}, {50, 15}};
NSRect sharedLabrect = {{10, 90}, {50, 15}};
NSRect swappedLabrect = {{10, 70}, {50, 15}};

NSRect staterect = {{50, 270}, {100, 15}};
NSRect userrect = {{48, 250}, {100, 15}};
NSRect ttyrect = {{36, 230}, {100, 15}};
NSRect pidrect = {{38, 210}, {100, 15}};
NSRect ppidrect = {{45, 190}, {100, 15}};
NSRect startTrect = {{73, 170}, {100, 15}};
NSRect cpuUsrect = {{74, 150}, {100, 15}};
NSRect sizerect = {{63, 130}, {100, 15}};
NSRect memrect = {{80, 110}, {100, 15}};
NSRect sharedrect = {{77, 90}, {100, 15}};
NSRect swappedrect = {{80, 70}, {100, 15}};

@implementation ProcObjWin

- (id)initWithFrame:(NSRect)frameRect procObj:(ProcObj *)apobj;
{
	NSFont *font;
	NSString *cellTxt;
  	NSRect okbuttrect = {{100, 10}, {80, 25}};
	char buf[256] = "";
	struct tm *t;
	time_t now, start_time;
  	double up, idle, elapsed_ticks, total_time, cpu_ticks, cpu_utilisation;
	FILE *filuptime;

	self = [super initWithFrame: frameRect];
  	if(self) {
		myPobj = apobj;
		procName = [myPobj myName];
		font = [NSFont boldSystemFontOfSize: 10];
		
		stateLabCell = [[NSCell alloc] initTextCell:@"state:"];
		[stateLabCell setFont: font];
		[stateLabCell setAlignment: NSLeftTextAlignment];
		
		userLabCell = [[NSCell alloc] initTextCell:@"user:"];
		[userLabCell setFont: font];
		[userLabCell setAlignment: NSLeftTextAlignment];

		ttyLabCell = [[NSCell alloc] initTextCell:@"tty:"];
		[ttyLabCell setFont: font];
		[ttyLabCell setAlignment: NSLeftTextAlignment];

		pidLabCell = [[NSCell alloc] initTextCell:@"pid:"];
		[pidLabCell setFont: font];
		[pidLabCell setAlignment: NSLeftTextAlignment];

		ppidLabCell = [[NSCell alloc] initTextCell:@"ppid:"];
		[ppidLabCell setFont: font];
		[ppidLabCell setAlignment: NSLeftTextAlignment];

		startTLabCell = [[NSCell alloc] initTextCell:@"start time:"];
		[startTLabCell setFont: font];
		[startTLabCell setAlignment: NSLeftTextAlignment];

		cpuUsLabCell = [[NSCell alloc] initTextCell:@"cpu usage:"];
		[cpuUsLabCell setFont: font];
		[cpuUsLabCell setAlignment: NSLeftTextAlignment];

		sizeLabCell = [[NSCell alloc] initTextCell:@"size (k):"];
		[sizeLabCell setFont: font];
		[sizeLabCell setAlignment: NSLeftTextAlignment];

		memLabCell = [[NSCell alloc] initTextCell:@"memory (k):"];
		[memLabCell setFont: font];
		[memLabCell setAlignment: NSLeftTextAlignment];

		sharedLabCell = [[NSCell alloc] initTextCell:@"shared (k):"];
		[sharedLabCell setFont: font];
		[sharedLabCell setAlignment: NSLeftTextAlignment];

		swappedLabCell = [[NSCell alloc] initTextCell:@"swapped (k):"];
		[swappedLabCell setFont: font];
		[swappedLabCell setAlignment: NSLeftTextAlignment];

		font = [NSFont systemFontOfSize: 10];

		stateCell = [[NSCell alloc] initTextCell: [myPobj state]];
		[stateCell setFont: font];
		[stateCell setAlignment: NSLeftTextAlignment];
	
		userCell = [[NSCell alloc] initTextCell: [myPobj user]];
		[userCell setFont: font];
		[userCell setAlignment: NSLeftTextAlignment];

		ttyCell = [[NSCell alloc] initTextCell: [myPobj tty]];
		[ttyCell setFont: font];
		[ttyCell setAlignment: NSLeftTextAlignment];

		cellTxt = [NSString stringWithFormat:@"%i", [myPobj pid]];
		pidCell = [[NSCell alloc] initTextCell: cellTxt];
		[pidCell setFont: font];
		[pidCell setAlignment: NSLeftTextAlignment];
		
		cellTxt = [NSString stringWithFormat:@"%i  (%@)", [myPobj ppid], [myPobj ppidname]];
		ppidCell = [[NSCell alloc] initTextCell: cellTxt];
		[ppidCell setFont: font];
		[ppidCell setAlignment: NSLeftTextAlignment];
	
		filuptime = fopen("/proc/uptime", "r");	
		fscanf(filuptime, "%lf %lf", &up, &idle);
		fclose(filuptime);
  		now = time(NULL);
  		elapsed_ticks = up * HZ - [myPobj start_time];
  		total_time = elapsed_ticks / HZ; 
		start_time = (long)(now - total_time);
		t = localtime(&start_time);
		cellTxt = [NSString stringWithFormat: @"%02i:%02i %02i.%02i.%04i", 
			t->tm_hour, t->tm_min, t->tm_mday, t->tm_mon + 1, t->tm_year + 1900];
		startTCell = [[NSCell alloc] initTextCell: cellTxt];
		[startTCell setFont: font];
		[startTCell setAlignment: NSLeftTextAlignment];

  		cpu_ticks = ([myPobj utime] + [myPobj stime]);
		cpu_utilisation = (cpu_ticks * 100 * 100/HZ) / elapsed_ticks;
		cellTxt = [NSString stringWithFormat: @"%f", cpu_utilisation];
		cpuUsCell = [[NSCell alloc] initTextCell: cellTxt];
		[cpuUsCell setFont: font];
		[cpuUsCell setAlignment: NSLeftTextAlignment];

		cellTxt = [NSString stringWithFormat: @"%ld", [myPobj size] * 4];
		sizeCell = [[NSCell alloc] initTextCell: cellTxt];
		[sizeCell setFont: font];
		[sizeCell setAlignment: NSLeftTextAlignment];

		cellTxt = [NSString stringWithFormat: @"%ld", [myPobj resident] * 4];
		memCell = [[NSCell alloc] initTextCell: cellTxt];
		[memCell setFont: font];
		[memCell setAlignment: NSLeftTextAlignment];

		cellTxt = [NSString stringWithFormat: @"%ld", [myPobj share] * 4];
		sharedCell = [[NSCell alloc] initTextCell: cellTxt];
		[sharedCell setFont: font];
		[sharedCell setAlignment: NSLeftTextAlignment];

		sprintf(buf, "%4ld", [myPobj vsize] ? 
						([myPobj end_code] - [myPobj start_code]) >> 10 : 0);
		cellTxt = [NSString stringWithCString: buf];
		swappedCell = [[NSCell alloc] initTextCell: cellTxt];
		[swappedCell setFont: font];
		[swappedCell setAlignment: NSLeftTextAlignment];

	  	okButt = [[NSButton alloc] initWithFrame: okbuttrect];
	  	[okButt setButtonType: NSMomentaryLight];
	  	[okButt setTitle: @"ok"];
	  	[okButt setTarget:myPobj];
	  	[okButt setAction:@selector(closeExplWin:)];		
		[self addSubview: okButt]; 
	}
	return self;
}

- (void)drawRect:(NSRect)rect
{ 
  	NSFont *font;

	[stateLabCell drawInteriorWithFrame: stateLabrect inView: self];
	[userLabCell drawInteriorWithFrame: userLabrect inView: self];
	[ttyLabCell drawInteriorWithFrame: ttyLabrect inView: self];
	[pidLabCell drawInteriorWithFrame: pidLabrect inView: self];
	[ppidLabCell drawInteriorWithFrame: ppidLabrect inView: self];
	[startTLabCell drawInteriorWithFrame: startTLabrect inView: self];
	[cpuUsLabCell drawInteriorWithFrame: cpuUsLabrect inView: self];
	[sizeLabCell drawInteriorWithFrame: sizeLabrect inView: self];
	[memLabCell drawInteriorWithFrame: memLabrect inView: self];
	[sharedLabCell drawInteriorWithFrame: sharedLabrect inView: self];
	[swappedLabCell drawInteriorWithFrame: swappedLabrect inView: self];

	[stateCell drawInteriorWithFrame: staterect inView: self];
	[userCell drawInteriorWithFrame: userrect inView: self];
	[ttyCell drawInteriorWithFrame: ttyrect inView: self];
	[pidCell drawInteriorWithFrame: pidrect inView: self];
	[ppidCell drawInteriorWithFrame: ppidrect inView: self];
	[startTCell drawInteriorWithFrame: startTrect inView: self];
	[cpuUsCell drawInteriorWithFrame: cpuUsrect inView: self];
	[sizeCell drawInteriorWithFrame: sizerect inView: self];
	[memCell drawInteriorWithFrame: memrect inView: self];
	[sharedCell drawInteriorWithFrame: sharedrect inView: self];
	[swappedCell drawInteriorWithFrame: swappedrect inView: self];

	// ---------------- Title ------------------
	[[NSColor blackColor] set];
	font = [NSFont systemFontOfSize: 18];
  	[font set];
  	PSmoveto(10, 315);
  	PSshow([procName cString]);

	// ---------------- Lines ------------------
  	[[NSColor darkGrayColor] set];
  	PSmoveto(0, 306);
 	PSlineto(190, 306);
	PSstroke();
  	[[NSColor whiteColor] set];
  	PSmoveto(0, 305);
 	PSlineto(190, 305);
	PSstroke();
	// ---------------- Lines ------------------
  	[[NSColor darkGrayColor] set];
  	PSmoveto(0, 45);
 	PSlineto(190, 45);
	PSstroke();
  	[[NSColor whiteColor] set];
  	PSmoveto(0, 44);
 	PSlineto(190, 44);
	PSstroke();
}

@end
