#ifndef PROCSFRAME_H
#define PROCSFRAME_H

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#include "common.h"
#include "procobj.h"

@interface ProcsFrame : NSView
{
	NSMutableArray *list, *templist1, *templist2; 
	int procspids[MAXPROC];
	NSImage *procIcon, *usrIcn, *ttyIcn, *cmdIcn;
	NSImage *procIconUnsl, *usrIcnUnsl, *ttyIcnUnsl, *cmdIcnUnsl;
}

- (id)initWithFrame:(NSRect)frameRect;
- (void)makeProcsObjects;
- (void)makeProcTree:(ProcObj *)insObj;
- (void)showProcsOfUser:(NSString *)usrname;
- (void)resizeWithOldSuperviewSize:(NSSize)oldFrameSize;
- (void)unselectOthers:(int)objid;
- (NSImage *)procIcon;
- (NSImage *)usrIcn;
- (NSImage *)ttyIcn;
- (NSImage *)cmdIcn;
- (NSImage *)procIconUnsl;
- (NSImage *)usrIcnUnsl;
- (NSImage *)ttyIcnUnsl;
- (NSImage *)cmdIcnUnsl;

- (NSString *)nameOfProcWithPid:(int)procpid;

@end

#endif // PROCSFRAME_H
